﻿using System.Collections;
using UnityEngine;

namespace Mod
{
    public class EMP3 : MonoBehaviour
    {
        private GameObject gameobjectStick;

        public Vector2 ChainConnector = new Vector2(0f, 0f);
        public Vector2 rodConnector = new Vector2(0f, 0.2f);

        Sprite Rod;
        private void Awake()
        {
            var mace = ModAPI.CreatePhysicalObject("Human", ModAPI.LoadSprite("Spine.png"));
            mace.transform.SetParent(gameObject.transform);
            mace.AddComponent<EMP4>();
            //mace.gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
           mace.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0f;
            mace.transform.localPosition = new Vector3(ChainConnector.x, ChainConnector.y + 0.005f);
         foreach (var hitbox in mace.gameObject.GetComponents<Collider2D>()){GameObject.Destroy(hitbox);}
            mace.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Glass");
            DistanceJoint2D joint = gameObject.AddComponent<DistanceJoint2D>();
            joint.maxDistanceOnly = false;
            joint.enableCollision = false;
            joint.distance = 0f;
            joint.autoConfigureDistance = true;
            joint.breakForce = Mathf.Infinity;
            joint.breakTorque = Mathf.Infinity;
            joint.anchor = ChainConnector;
            joint.connectedBody = mace.GetComponent<Rigidbody2D>();
            joint.connectedAnchor = rodConnector;
            JointCreated(joint);
        }

        void JointCreated(DistanceJoint2D joint)
        {
            EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
            energyWireBehaviour.WireWidth = 0.0001f;
            energyWireBehaviour.typedJoint = joint;
            energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Bandage");

            
        }
    }
}